import { Injectable } from '@nestjs/common';
import { DateTime, TimeZone } from 'timezonecomplete';
import { IConvertTime } from '../../domain/interfaces/time-converter.interface';

@Injectable()
export class TimeConverter implements IConvertTime {
  toUtcDate = (date: Date, timezone: string): Date => {
    try {
      return new Date(
        new DateTime(
          `${date.getFullYear()}-${date.getMonth()}-${date.getDate()}T${date.getHours()}:${date.getMinutes()}`,
          TimeZone.zone(timezone, false),
        )
          .convert(TimeZone.zone('UTC'))
          .toIsoString(),
      );
    } catch (e) {
      return undefined;
    }
  };
}
